{
  "extends": "standard-with-typescript",
  "rules": {
    "eol-last": [
      "error",
      "always"
    ],
    "indent": "off",
    "no-lone-blocks": "off",
    "no-mixed-operators": "off",
    "max-len": [
      "error",
      {
        "code": 140
      }
    ],
    "array-bracket-spacing": [
      "error",
      "always"
    ],
    "quote-props": [
      "error",
      "consistent-as-needed"
    ],
    "padded-blocks": "off",
    "prefer-regex-literals": "off",
    "no-async-promise-executor": "off",
    "dot-notation": "off",
    "promise/param-names": "off",
    "import/first": "off",
    "operator-linebreak": [
      "error",
      "after",
      {
        "overrides": {
          "?": "before",
          ":": "before"
        }
      }
    ],
    "quotes": "off",

    "no-constant-binary-expression": "error",

    "@typescript-eslint/indent": [
      "error",
      2,
      {
        "SwitchCase": 1,
        "MemberExpression": "off",
        // https://github.com/eslint/eslint/issues/15299
        "ignoredNodes": ["PropertyDefinition"]
      }
    ],
    "@typescript-eslint/consistent-type-assertions": [
      "error",
      {
        "assertionStyle": "as"
      }
    ],
    "@typescript-eslint/array-type": [
      "error",
      {
        "default": "array"
      }
    ],
    "@typescript-eslint/restrict-template-expressions": [
      "off",
      {
        "allowNumber": "true"
      }
    ],
    "@typescript-eslint/no-this-alias": [
      "error",
      {
        "allowDestructuring": true, // Allow `const { props, state } = this`; false by default
        "allowedNames": ["self"] // Allow `const self = this`; `[]` by default
      }
    ],

    "@typescript-eslint/return-await": "off",
    "@typescript-eslint/dot-notation": "off",
    "@typescript-eslint/method-signature-style": "off",
    "@typescript-eslint/no-base-to-string": "off",
    "@typescript-eslint/quotes": [
        "error",
        "single",
        {
            "avoidEscape": true,
            "allowTemplateLiterals": true
        }
    ],
    "@typescript-eslint/no-var-requires": "off",
    "@typescript-eslint/explicit-function-return-type": "off",
    "@typescript-eslint/promise-function-async": "off",
    "@typescript-eslint/no-dynamic-delete": "off",
    "@typescript-eslint/no-unnecessary-boolean-literal-compare": "off",
    "@typescript-eslint/strict-boolean-expressions": "off",
    "@typescript-eslint/consistent-type-definitions": "off",
    "@typescript-eslint/no-misused-promises": "off",
    "@typescript-eslint/no-namespace": "off",
    "@typescript-eslint/no-empty-interface": "off",
    "@typescript-eslint/no-extraneous-class": "off",
    "@typescript-eslint/no-use-before-define": "off",

    "require-await": "off",
    "@typescript-eslint/require-await": "error",

    // bugged but useful
    "@typescript-eslint/restrict-plus-operands": "off",

    // Requires strictNullChecks
    "@typescript-eslint/prefer-nullish-coalescing": "off",
    "@typescript-eslint/consistent-type-imports": "off",
    "@typescript-eslint/consistent-indexed-object-style": "off",
    "@typescript-eslint/no-confusing-void-expression": "off",
    "@typescript-eslint/consistent-type-exports": "off",
    "@typescript-eslint/key-spacing": "off",

    "@typescript-eslint/no-unsafe-argument": "off",

    "@typescript-eslint/ban-types": [
      "error",
      {
        "types": {
          "{}": false,
          "Function": false
        },
        "extendDefaults": true
      }
    ]
  },
  "ignorePatterns": [
    "node_modules/"
  ],
  "parserOptions": {
    "project": [
      "./tsconfig.json"
    ]
  }
}
